// TK_MD.cpp : Defines the entry point for the application.
//

//#include "stdafx.h"
#define INI_FILE	"\\TK_MD.ini"
//#define STRICT
#define TOP_RIGHT 0
#define TOP_LEFT  1
#define BOTTOM_RIGHT  2
#define BOTTOM_LEFT  3

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <shlwapi.h>
#include <sql.h>
#include <SQLEXT.H>
#include <direct.h>
#include <stdio.h>
//#include "TREEDLG.h"
#include "DIREXEC.h"
#include "resource.h"

void WriteComboItems(LPCTSTR SectionName, HWND hWndCombo);
int ComboInit(LPCTSTR SectionName, HWND hWndCombo);
void InsertComboItem(HWND hWndCombo, int MruQuantity, LPCTSTR szItem);
void ResizeControl(int cx, int cy, int CtrlID, int Mode, BOOL Sizing);
void WinOnSize(int cx, int cy);

BOOL InitListView(HWND hwndListView);
void RefreshViews();
LRESULT CALLBACK MainDlgProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
HWND hWnd, hWndListView, hWndComboSelect, hWndComboSQL;
void ScreenToClientRect(HWND hWnd, RECT* rect);
//void DoTree();

direxec x;
direxec *sql;
char szString[128]="";
char szDSN[64], IniPath[_MAX_PATH],  szSERVER[64], szPWD[64], szUID[64], szDRIVER[64], szDATABASES[64];
DWORD r;
int k=0, mru_sel, mru_SQL; // quantity of MRU items in Combo Select and Combo SQL
RECT WndRect;	//	Dialog Size
HICON hIcon1;   

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow)
{
int ret;
    UNREFERENCED_PARAMETER( hPrevInstance );
    UNREFERENCED_PARAMETER( lpCmdLine );
    UNREFERENCED_PARAMETER( nCmdShow);
	
//	char *abc = "sss %i www";
//	char buf[1000];
//	sprintf(buf, abc, 111 );

	InitCommonControls();
//	hInst = hInstance;


	_getdcwd( _getdrive(), IniPath, _MAX_PATH ) ;
	strcat(IniPath, INI_FILE);
 
	ret = DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)MainDlgProc);
	if (ret == -1)
	{	LPVOID lpMsgBuf;
		FormatMessage(	FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_IGNORE_INSERTS,  NULL,  GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,    0,    NULL );
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, "  ", MB_OK | MB_ICONINFORMATION );
		LocalFree( lpMsgBuf );
	}
	else
	{
/*		GetWindowRect(hWnd, &WndRect);
		WritePrivateProfileString("DIALOG", "left", itoa(WndRect.left,szDSN,10), IniPath);
		WritePrivateProfileString("DIALOG", "right", itoa(WndRect.right,szDSN,10), IniPath);
		WritePrivateProfileString("DIALOG", "top", itoa(WndRect.top,szDSN,10), IniPath);
		WritePrivateProfileString("DIALOG", "bottom", itoa(WndRect.bottom,szDSN,10), IniPath);
*/	}
	return ret;
}


/**************************************************************************\
*				 MainDlgProc()
\**************************************************************************/
LRESULT CALLBACK MainDlgProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  UNREFERENCED_PARAMETER(lParam);
  char *StrSelect;

  switch (message) {
    case WM_SYSCOMMAND:
      if (wParam == SC_CLOSE) {
        EndDialog (hwnd, TRUE);
        return TRUE;
      } else
        return FALSE;
    break;

	case WM_SIZE:
		WinOnSize(LOWORD(lParam), HIWORD(lParam));
		return TRUE;

    case WM_INITDIALOG:
		hWnd = hwnd;
		hWndListView = GetDlgItem(hWnd, IDC_LIST_DATA);
		hWndComboSelect = GetDlgItem(hWnd, IDC_COMBO_SELECT);
		hWndComboSQL = GetDlgItem(hWnd, IDC_COMBO_SQL);

		GetClientRect(hwnd, &WndRect);
		hIcon1 = LoadIcon(NULL, "IDI_ICON1"); 

		SetClassLong(hWnd, GCL_HICON, (long) hIcon1);

		if( GetPrivateProfileString("ODBC","DSN","",szDSN, sizeof(szDSN), IniPath) > 0 )
			{ strcat(szString, "DSN="); strcat(szString, szDSN); strcat(szString, ";"); }
		if(GetPrivateProfileString("ODBC","DRIVER","",szDRIVER, sizeof(szDRIVER), IniPath) > 0 )
			{ strcpy(szString, "DRIVER="); strcat(szString, szDRIVER); strcat(szString, ";"); }
		if(GetPrivateProfileString("ODBC","SERVER","",szSERVER, sizeof(szSERVER), IniPath) > 0)
			{ strcat(szString, "SERVER="); strcat(szString, szSERVER); strcat(szString, ";"); }
		if(GetPrivateProfileString("ODBC","UID","sa",szUID, sizeof(szUID), IniPath) > 0)
			{ strcat(szString, "UID="); strcat(szString, szUID); strcat(szString, ";"); }
		if(GetPrivateProfileString("ODBC","PASSWORD","",szPWD, sizeof(szPWD), IniPath) > 0)
			{ strcat(szString, "PWD="); strcat(szString, szPWD); strcat(szString, ";"); }
		if(GetPrivateProfileString("ODBC","DATABASES","",szDATABASES, sizeof(szDATABASES), IniPath) > 0)
			{ strcat(szString, "DATABASE="); strcat(szString, szDATABASES); strcat(szString, ";"); }
		x.sqlconn((unsigned char *) szString);
		mru_sel=ComboInit("MRU_SELECT", hWndComboSelect);
		mru_SQL=ComboInit("MRU_SQL", hWndComboSQL);
		//InitListView(hWndListView);
		return TRUE;
    break;

    case WM_COMMAND:

		switch (LOWORD(wParam)) {
		case IDC_BUTTON_REFRESH:
		  StrSelect = new char[128];
		  GetDlgItemText(hWnd, IDC_COMBO_SELECT, StrSelect, 128);
		  InsertComboItem(hWndComboSelect, mru_sel, StrSelect);
		  WriteComboItems("MRU_SELECT", hWndComboSelect); // write to ini
		  InitListView(hWndListView);
		  delete StrSelect;
	
		  break;

		case ID_TREE:
//			DoTree();
			//DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_TREE), NULL, (DLGPROC)TreeDlgProc);
		  break;

		case IDC_BUTTON_REFRESH2:
			StrSelect = new char[128];
			GetDlgItemText(hWnd, IDC_COMBO_SQL, StrSelect, 128);
		    InsertComboItem(hWndComboSQL, mru_SQL, StrSelect);
			WriteComboItems("MRU_SQL", hWndComboSQL); // write to ini
 			SetCursor(LoadCursor(NULL, IDC_WAIT));
			sql = new direxec;
			
			sql->sqlconn((UCHAR*) szString);
			sql->sqlexec((UCHAR*) StrSelect);
			delete StrSelect;
			delete sql;
		    SetCursor(LoadCursor(NULL, IDC_ARROW));
		  break;

		  /*		case IDC_EDIT_SEARCH:
		  if (HIWORD(wParam) == EN_CHANGE) RefreshViews();
          break;
*/
		case IDOK:	case IDCANCEL:
			EndDialog (hwnd, TRUE);
          break;
		} // (LOWORD(wParam))
		return TRUE;
    break; /* end WM_COMMAND */

    default: return FALSE;
  } /* end switch(message) */
}


#define MAX_COLUMNS	256
#define MAX_STRING	256

/******************************************************************************
     InitListView
******************************************************************************/
BOOL InitListView(HWND hwndListView)
{
 LV_COLUMN   lvColumn;
 unsigned int     ncol;
 Column Col;
 ListView_DeleteAllItems(hwndListView);

 lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
 lvColumn.fmt = LVCFMT_LEFT;
 lvColumn.cx = 130;
 
 unsigned char *str[MAX_COLUMNS];
 char StrSelect[140]="SELECT  "; 

 GetDlgItemText(hWnd, IDC_COMBO_SELECT, &StrSelect[7], 128);
 
 SetCursor(LoadCursor(NULL, IDC_WAIT));
 x.sqlexec((UCHAR*) StrSelect);
 if(!x.Bad())
 {
 for(ncol = 0; !x.Bad() && ncol<MAX_COLUMNS; ncol++)
 {
   str[ncol] = new UCHAR[MAX_STRING];
	// ncol+1 = zero col is bookmark ! I don't need it!
   x.sqlGetColumn(ncol+1, &Col);
   if(!x.Bad())
   {
     x.sqlBind(ncol+1, SQL_CHAR /*Col.DataTypePtr*/, str[ncol], MAX_STRING, (long*)&Col.cbSize);
     
	 if(!x.Bad())
	 {
	  lvColumn.pszText = (char*)&Col.szColName;
	  ListView_DeleteColumn(hwndListView, ncol); // delete previos created
      ListView_InsertColumn(hwndListView, ncol, &lvColumn);
	 }
   }
 }

 LVITEM lvi;
 lvi.mask = LVIF_TEXT ;
 lvi.iSubItem = 0;
 UINT ColNum = ncol-1; 
 UINT j=0;
 while (TRUE) {
    x.sqlExtFetch(SQL_FETCH_NEXT, 1);
    if (!x.Bad())         
    {
     lvi.iItem = lvi.lParam = j;
     lvi.pszText = (LPTSTR) str[0];
	 if(ListView_InsertItem(hWndListView, &lvi)==-1) 	 break;
	 for(ncol=1; ncol<ColNum; ncol++)
	     ListView_SetItemText(hWndListView, j, ncol, (LPSTR) str[ncol]);
     j++;
	} 
	else break;
 }
 for(ncol=0; ncol<ColNum; ncol++)	 delete str[ncol];
 }
 char Tmp[128]="TK MustDie. Selected "; 
 itoa(ListView_GetItemCount(hWndListView), &Tmp[21], 10); // RecCount
 SetWindowText(hWnd, strcat(Tmp, " records."));

 SetCursor(LoadCursor(NULL, IDC_ARROW));
 return TRUE;
}

int ComboInit(LPCTSTR SectionName, HWND hWndCombo)
{
char tmp1[10], tmp2[128];
for(int mru=1; mru<64; mru++)  
	if(GetPrivateProfileString(SectionName, itoa(mru, tmp1, 10),"",tmp2, sizeof(tmp2), IniPath) > 0)
	{
		if (mru==1)		SetDlgItemText(hWnd, GetDlgCtrlID(hWndCombo), (LPCTSTR) tmp2);
		SendMessage(hWndCombo, CB_ADDSTRING, 0,(LPARAM) tmp2);
	}
	else	return (mru = (mru==1)? 0: mru);
return mru;
}

void InsertComboItem(HWND hWndCombo, int MruQuantity, LPCTSTR szItem)
{
  if(SendMessage(hWndCombo, CB_FINDSTRINGEXACT, 0,(LPARAM) szItem) == CB_ERR ) // check existing already
  {
	 if(SendMessage(hWndCombo, CB_GETCOUNT, 0, 0) >= MruQuantity) // check limits
		SendMessage(hWndCombo, CB_DELETESTRING, MruQuantity, 0);	// delete last 
	 SendMessage(hWndCombo, CB_INSERTSTRING , 0,(LPARAM) szItem); // insert new one
  }
}

void WriteComboItems(LPCTSTR SectionName, HWND hWndCombo)
{
 int mru = SendMessage(hWndCombo, CB_GETCOUNT, 0, 0);
 char szTmp[10], szTmp2[64];
 for(int k=1; k<=mru; k++)
 {
	SendMessage(hWndCombo, CB_GETLBTEXT, k-1, (LPARAM) szTmp2); 
	WritePrivateProfileString(SectionName, itoa(k, szTmp, 10), szTmp2, IniPath);
 }
}

/***************************************************************/
void WinOnSize(int cx, int cy) 
{
  if( cy > 100 && cx> 100)
  {
	ResizeControl(cx, cy, IDC_LIST_DATA, TOP_LEFT, TRUE);
	ResizeControl(cx, cy, IDC_BUTTON_REFRESH, BOTTOM_RIGHT, TRUE);
	ResizeControl(cx, cy, IDC_BUTTON_REFRESH2, BOTTOM_RIGHT, TRUE);
	ResizeControl(cx, cy, IDC_STATIC1, BOTTOM_LEFT, FALSE);
	ResizeControl(cx, cy, IDC_COMBO_SELECT, BOTTOM_LEFT, TRUE);
	ResizeControl(cx, cy, IDC_COMBO_SQL, BOTTOM_LEFT, TRUE);
	GetClientRect(hWnd, &WndRect);
  }
}

void ResizeControl(int cx, int cy, int CtrlID, int Mode, BOOL Sizing)
{
	RECT rect;
	int dx = cx - (WndRect.right - WndRect.left);
	int dy = cy - (WndRect.bottom - WndRect.top);

	HWND Ctrl = GetDlgItem(hWnd, CtrlID);
	if(Ctrl)
	{
		GetWindowRect( Ctrl, &rect );
		
		ScreenToClientRect(hWnd, &rect);
		switch (Mode)
		{
		case TOP_LEFT:
			rect.bottom += dy ;
			rect.right	+= dx ;
			break;
		case TOP_RIGHT:
			rect.bottom += (Sizing)? dy : 0 ;
			rect.left	+= dx ;
			rect.right	+= dx ;
			break;
		case BOTTOM_RIGHT:
			rect.top	+= dy ;
			rect.bottom += dy ;
			rect.left	+= dx ;
			rect.right	+= dx ;
			break;
		case BOTTOM_LEFT:
			rect.right	+= (Sizing)? dx : 0;
			rect.bottom += dy ;
			rect.top	+= dy ;
			break;
		}
		rect.bottom = (rect.bottom<0)?	0: rect.bottom;
		rect.left	= (rect.left<0)?	0: rect.left;
		rect.right	= (rect.right<0)?	0: rect.right;
		rect.top	= (rect.top<0)?		0: rect.top;
		
		MoveWindow( Ctrl, rect.left, rect.top, 
					rect.right-rect.left, rect.bottom - rect.top, TRUE);
	}
}

void ScreenToClientRect(HWND hWnd, RECT* rect)
{
	POINT UpLeft, BotRight;

	UpLeft.x = rect->left;  UpLeft.y = rect->top;
	BotRight.x = rect->right; BotRight.y = rect->bottom;
	ScreenToClient(hWnd, &UpLeft);
	ScreenToClient(hWnd, &BotRight);
	
	rect->left  = UpLeft.x  ; rect->top = UpLeft.y;
	rect->right = BotRight.x; rect->bottom = BotRight.y ;
}

/*
void DoTree()
{
// TODO: Add your control notification handler code here
//
//
// Design and implementation cinoban@yahoo.com 
// 13 Jan 2000 15:14
//

//CString strWords;
char strWords[64];

// This is a rectangle control
CWnd* pWnd = GetDlgItem(IDC_STATIC_PREVIEW); 

CDC* dc;
CDC memoriDC;
CBitmap memBMP;
CBitmap* pOldBMP;
CFont fnt;
CFont* pOldFnt;
CRect rect;
CRect rectMemory;
CSize zMetrix;

//
//
//
CPrintDialog pdlg(FALSE);
DOCINFO di;
CDC prnDC;

di.cbSize = sizeof(DOCINFO);
di.lpszDocName = "This string will appear in Printer
Queue";
di.lpszOutput = NULL;     
di.lpszDatatype = NULL;
di.fwType = 0;

//
// Get current printer setting
//
pdlg.GetDefaults();


//
dc = pWnd->GetDC();
pWnd->GetClientRect(&rect);

// DC printer???
if( !prnDC.Attach(pdlg.GetPrinterDC()) )
AfxMessageBox("Invalid Printer DC");
memoriDC.CreateCompatibleDC(&prnDC); // Create DC for
Preview

//
// Get the resolution of Screen and Current Default
Printer
//
int iPrnX = prnDC.GetDeviceCaps(HORZRES);
int iPrnY = prnDC.GetDeviceCaps(VERTRES);
int iMonX = dc->GetDeviceCaps(HORZRES); // Device
Target is Monitor
int iMonY = dc->GetDeviceCaps(VERTRES);


rectMemory.top = 0;
rectMemory.left = 0;
rectMemory.bottom = iPrnY;
rectMemory.right = iPrnX;

//
// Create a Memory Bitmap that is compatible with the
Printer DC
// then select or make the bitmap as current GDI
active object
//
memBMP.CreateCompatibleBitmap(&prnDC,
rectMemory.Width(), rectMemory.Height());
pOldBMP = memoriDC.SelectObject(&memBMP);

//
// Clear memory DC or in other words
// paint the bitmap with white colour and transparent
text
//
memoriDC.SetBkMode(TRANSPARENT);
memoriDC.SetTextColor(RGB(0, 0, 0));
memoriDC.PatBlt(0, 0, rectMemory.Width(),
rectMemory.Height(), WHITENESS);

//
// Prepare the font
//
int iPointz = 100;
fnt.CreatePointFont(iPointz, "OCR A", &memoriDC);
strWords.Format("This is line number    ");        //
Test string
pOldFnt = memoriDC.SelectObject(&fnt);
zMetrix = memoriDC.GetTextExtent(strWords);
int iPos = 0;

//
// Write string or Paint something
//
int iMaksimal = 0;
int iLineHeight = 1;
int iLoop;
CString strPuncak;

//
// Calculate how many lines we could fit
//
for(iLoop = 1; iLoop < 100; iLoop++)
{
if( ((zMetrix.cy+iLineHeight)*iLoop) < iPrnY )
iMaksimal++;
}

strPuncak.Format("Maximum Amount of line(s) for %d
points are %d lines", iPointz, iMaksimal);

//
//
//
for(iLoop = 0; iLoop < iMaksimal; iLoop++)
{
strWords.Format("This is line %d", iLoop);
memoriDC.TextOut(0, iLoop*(zMetrix.cy+iLineHeight),
strWords);
}

//
// Reseting font
//
memoriDC.SelectObject(pOldFnt);

//
// Calculate ratio
//
float fXRatio = (float) iMonX/iPrnX;
float fYRatio = (float) iMonY/iPrnY;


//  iLebar = Width
//  iTinggi = Height
//  iXPosisiPreview = horisontal location of preview
//  iYPosisiPreview = vertical location of preview
//
int iLebar = rect.Width()*fXRatio;
int iTinggi = rect.Height()*fYRatio;
int iXPosisiPreview = (rect.Width() - iLebar)/2;
int iYPosisiPreview = (rect.Height() - iTinggi)/2;
CPen pen(PS_SOLID, 2, RGB(255, 0, 0));
CPen* pOldPen;

//
// Create an outline
// 
pOldPen = dc->SelectObject(&pen);
dc->Rectangle(iXPosisiPreview, iYPosisiPreview ,
iXPosisiPreview + iLebar + 2 , iYPosisiPreview +
iTinggi + 2);
dc->SelectObject(pOldPen);

//
// Put in the box
//
dc->StretchBlt(iXPosisiPreview , iYPosisiPreview ,
iLebar, iTinggi,
&memoriDC, 0, 0, rectMemory.Width(),
rectMemory.Height(), SRCCOPY);

//
// Cleaning Up
//
fnt.DeleteObject();
memoriDC.SelectObject(pOldBMP);
memoriDC.DeleteDC();
memBMP.DeleteObject();
prnDC.Detach();

//
pWnd->ReleaseDC(dc);

}
*/