#include <windows.H>
#include <mbstring.h>
#include <sql.h>
#include <SQLEXT.H>

#define MAX_DATA 100
#define MYSQLSUCCESS(rc) ((rc==SQL_SUCCESS)||(rc==SQL_SUCCESS_WITH_INFO))
#define STR_LEN 128+1
#define REM_LEN 254+1

struct Column
{ 
	unsigned char szColName[32];
	//unsigned int ColSize;
	SQLSMALLINT cbSize,	// total number of bytes (excluding the null-termination byte) available to return in *szColName
				DataTypePtr;	//Ptr to a buffer in which to return the SQL data type of the column
	SQLUINTEGER ColumnSizePtr;	// size of the column on the data source
	SQLSMALLINT DecimalDigitsPtr,
				NullablePtr;
};

class direxec {
	SQLHENV  henv;
	SQLHDBC  hdbc;
	SQLHSTMT hstmt;
	SQLRETURN  retcode;
	
	unsigned char szData[MAX_DATA];	// Returned data storage
	SDWORD cbRecCount;			// Output length of data
	unsigned char rec_count[8];
	unsigned char ConnStrIn[1024];	// Connection String

	UDWORD crow, irow; 
    UWORD rgfRowStatus[1]; 
private:
	SQLCHAR   szColumnName[STR_LEN], szTypeName[STR_LEN],  ColumnSize, DataType, SQLDataType;
		/* Declare buffers for bytes available to return */
	SQLINTEGER cbColumnName, cbDataType, cbTypeName, cbColumnSize, cbSQLDataType; 
	unsigned char szTableName[32]; // Current Working Table
	
public:
	void direxec::sqlGetColumn(UINT ColNum, Column *Col); // Gets column info
	BOOL Bad();
	direxec();						// Constructor
	direxec::~direxec();			// 		
	void sqlconn(unsigned char * ConnString = NULL);// Allocate env,stat,and connect
	void sqlexec(unsigned char *);	// Execute SQL statement
	void sqlBind(UWORD,SWORD,PTR,SDWORD,SDWORD FAR*);// Binds data to var
    void sqlExtFetch(UWORD fFetchType, SDWORD irow);	

	void sqldisconn();				// Free pointers to env,stat,conn,
									// and disconnect.	
	void error_out(HSTMT, SQLSMALLINT HandleType=SQL_HANDLE_STMT);	// Displays errors.
	const char* RecCount();
};